//
// Created by robin on 1/31/18.
//

#include <QTcpSocket>
#include "dns-server/QTcpDnsServer.h"
#include "QTcpDnsServerClient.h"

namespace QDns
{
    namespace Server
    {
        QTcpDnsServer::QTcpDnsServer()
            : m_socket(new QTcpServer(this))
        {
            connect(m_socket, &QTcpServer::newConnection, this, &QTcpDnsServer::onNewConnection);
        }

        bool QTcpDnsServer::start(const QHostAddress &host, quint16 port)
        {
            return m_socket->listen(host, port);
        }

        void QTcpDnsServer::onNewConnection()
        {
            auto socket = m_socket->nextPendingConnection();
            if (socket == nullptr)
            {
                return;
            }
            auto client = new QTcpDnsServerClient(socket, this);
            connect(socket, &QTcpSocket::disconnected, [client, this]()
            {
                m_clients.removeOne(client);
                client->deleteLater();
            });
            connect(client, &QTcpDnsServerClient::onRequest, [this](QDnsServer::OnRequestParams params)
            {
                emit onRequest(params);
            });
            m_clients.append(client);
        }
    }
}